/**
 * Copyright (C) 2012 Ness Computing, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.nesscomputing.exception;

import com.google.inject.AbstractModule;
import com.google.inject.multibindings.MapBinder;

import com.nesscomputing.httpclient.guice.HttpClientModule;

/**
 * Add support for mapping NessApiException subclasses to and from HTTP responses.
 */
public final class NessApiExceptionModule extends AbstractModule
{
    @Override
    protected void configure()
    {
        bind (ResponseMapper.class);

        HttpClientModule.bindNewObserver(binder()).to(ExceptionObserver.class);
        MapBinder.newMapBinder(binder(), String.class, ExceptionReviver.class).permitDuplicates();
    }

    @Override
    public int hashCode()
    {
        return getClass().hashCode();
    }

    @Override
    public boolean equals(Object obj)
    {
        return obj instanceof NessApiExceptionModule;
    }
}
